/*
This is a runemod powerup plugin that interfaces with runemod_base.amxx

About this rune:
Pistol & knifes have poison damage

Credits:
Ops in #AMXmod @ Quakenet for alot of help ( + AssKicker & CheesyPeteza ) 
Thanks to BAILOPAN & PM for help on misc problems
kaddar for orginal runemod

Todo:
Balance it out

Changelog:
 1.0.0
 	- First release
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <fun>
#include "runemod.inc"		// We need to include this file, as it contains info we need. Like #define`s and stocks

new g_HasRune[MAXPLAYERS+1]
new g_MaxPlayers

public plugin_init() 
{
	register_plugin("RuneMod Chicken", "1.0.0", "AdogeN")
	g_MaxPlayers = get_maxplayers()
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1")
	RegisterPlugin("ChickenName","ChickenDisc",{220,220,0},API_ROUNDSTARTED+API_EVENTCHANGEWEAPON+API_USELANGSYSTEM)	
}
stock CheckWeapon(id,WeaponIndex)
{
	if(IsPrimarlyWeapon(WeaponIndex))
	{
		IsPrimarlyWeapon(WeaponIndex)
		client_cmd(id,"slot1;drop")
		client_cmd(id,"slot2;drop")
		client_print(id,print_chat,"%L",LANG_PLAYER,"NoPrimaryWeaponDroped")
	}
}
public API_CurWeaponChange(id,WeaponIndex)
{
	if(g_HasRune[id] == 1)
	{
		CheckWeapon(id,WeaponIndex)
	}
	return PLUGIN_CONTINUE
}
// This function is used base plugin to inform this plugin that a user has picked up the rune.
public API_PickUpRune(id) 
{
	g_HasRune[id] = 1
	cs_set_user_model(id, "amonster3")
	if(cs_get_user_team(id)==CS_TEAM_T)
				{
					set_rendering(id,kRenderFxGlowShell,5,0,0,kRenderTransAlpha,255)
				}
				else
				{
					set_rendering(id,kRenderFxGlowShell,0,0,5,kRenderTransAlpha,255)
				}
	new tclip, tammo 
	new weapon = get_user_weapon(id,tclip,tammo)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_tot.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
	new weapons[32],num
	get_user_weapons(id,weapons,num)
	for(new i=0;i<=num;i++)
	{
		CheckWeapon(id,weapons[i])
	}
}

public API_RoundStarted()
{
	for(new i=1;i<=g_MaxPlayers;i++) if(g_HasRune[i])
		{
			API_PickUpRune(i)
		}		
}

public Event_CurWeapon(id)
{
	if (!is_user_alive(id) || g_HasRune[id] == 0) {
		return PLUGIN_CONTINUE
	}
	
	new weapon = read_data(2)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_tot.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
	return PLUGIN_CONTINUE
}

public plugin_precache() {
	precache_model("models/player/amonster3/amonster3.mdl")
	precache_model("models/knife/v_tot.mdl")
	precache_model("models/knife/p_tot.mdl")
}

public API_DropedRune(id,Reason) //This function is called by the base plugin to inform about the user droped his rune for whatever reason ( he could have used droprune or died )
{	
	g_HasRune[id] = 0
	cs_reset_user_model(id)
	set_rendering(id,kRenderFxNone,0,0,0,kRenderTransAlpha,255)
}
stock RemovePrimary(id)
{
	//engclient_cmd(id,"drop")
	client_cmd(id,"slot1;drop")
	client_cmd(id,"slot2;drop")
}
stock IsPrimarlyWeapon(WeaponIndex)
{
	if(WeaponIndex == CSW_SCOUT || WeaponIndex == CSW_XM1014 || WeaponIndex == CSW_MAC10 || WeaponIndex == CSW_AUG || WeaponIndex == CSW_UMP45 || 
	WeaponIndex == CSW_SG550 || WeaponIndex == CSW_GALI || WeaponIndex == CSW_GALIL || WeaponIndex == CSW_FAMAS || WeaponIndex == CSW_AWP || 
	WeaponIndex == CSW_MP5NAVY || WeaponIndex == CSW_M249 || WeaponIndex == CSW_M3 || WeaponIndex == CSW_M4A1 || WeaponIndex == CSW_TMP || 
	WeaponIndex == CSW_G3SG1 || WeaponIndex == CSW_SG552 || WeaponIndex == CSW_AK47 || WeaponIndex == CSW_P90 || WeaponIndex == CSW_P228 ||
	WeaponIndex == CSW_ELITE || WeaponIndex == CSW_FIVESEVEN || WeaponIndex == CSW_USP || WeaponIndex == CSW_GLOCK18 || WeaponIndex == CSW_DEAGLE)
		return 1
	return 0
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ ansicpg949\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset129 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1042\\ f0\\ fs16 \n\\ par }
*/
