/*
About:
This is a runemod powerup plugin that interfaces with runemod_base.amxx

About this rune:
Your HP regeneration up to 160

Credits:
Ops in #AMXmod @ Quakenet for alot of help ( + AssKicker & CheesyPeteza ) 
Thanks to BAILOPAN & PM for help on misc problems
kaddar for orginal runemod

Todo:
No plans
 1.0.1
	- Fixed: HP never reaching the max
 1.0.0
 	- First release
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <fun>
#include "runemod.inc"		// We need to include this file, as it contains info we need. Like #define`s and stocks

#define REGEN_MAXHP 200.0
#define REGEN_TIMER 1.0
#define REGEN_AMOUNT 2.0		// self heal
#define StartHP 100.0
#define REGEN_AMOUNTOTHERS 2.0
#define REGEN_DISTANCE 200.0

new g_MaxPlayers 
new g_HasRune[MAXPLAYERS+1] 	// This is the Array used to store if the user is holding a rune.(Remember the base plugin informs this plugin once he picks up a rune.)

public plugin_init() 
{
	register_plugin("RuneMod Monster", "1.0.0", "AdogeN")
	g_MaxPlayers = get_maxplayers()
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1")
	RegisterPlugin("MonsterName","MonsterDisc",{79,30,40},API_ROUNDSTARTED+API_USELANGSYSTEM)
	
	g_MaxPlayers = get_maxplayers()
}

public plugin_precache()
{
	precache_model("models/player/amonster/amonster.mdl")
        precache_model("models/knife/v_tot.mdl")
	precache_model("models/knife/p_tot.mdl")
}

public Task_HPRegenLoop(id)
{
	new Float: NewHP
	if(entity_get_float(id, EV_FL_health) < REGEN_MAXHP) 
	{
		NewHP = entity_get_float(id, EV_FL_health) + REGEN_AMOUNT
	
		if(NewHP >= REGEN_MAXHP) // If user regened to much HP. We set the MAXHP
			NewHP = REGEN_MAXHP
		entity_set_float(id, EV_FL_health,NewHP)
	}
	
	new Team = get_user_team(id)

	for(new i=1;i<=g_MaxPlayers;i++) if(get_user_team(i) == Team && is_user_alive(i) && i != id && entity_range(id,i) <= REGEN_DISTANCE)
	{
		NewHP = entity_get_float(i, EV_FL_health) + REGEN_AMOUNTOTHERS
		
		if(NewHP >= StartHP) // If user regened to much HP. We set the MAXHP
			NewHP = StartHP

		entity_set_float(i, EV_FL_health,NewHP)
	}
	return PLUGIN_CONTINUE
}

public API_DropedRune(id,Reason) //This function is called by the base plugin to inform about the user droped his rune for whatever reason ( he could have used droprune or died )
{	
	g_HasRune[id] = 0
        cs_reset_user_model(id)
	set_rendering(id,kRenderFxNone,0,0,0,kRenderTransAlpha,255)
        if(entity_get_float(id, EV_FL_health) > StartHP) entity_set_float(id, EV_FL_health,StartHP)
        remove_task(id)
}

// This function is used base plugin to inform this plugin that a user has picked up the rune.
public API_PickUpRune(id) 
{
	g_HasRune[id] = 1
	set_task(REGEN_TIMER,"Task_HPRegenLoop",id,_,_,"b")
        cs_set_user_model(id, "amonster")
	if(cs_get_user_team(id)==CS_TEAM_T)
				{
					set_rendering(id,kRenderFxGlowShell,20,0,0,kRenderTransAlpha,255)
				}
				else
				{
					set_rendering(id,kRenderFxGlowShell,0,0,20,kRenderTransAlpha,255)
				}
        new tclip, tammo 
	new weapon = get_user_weapon(id,tclip,tammo)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_tot.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
}

public API_RoundStarted()
{
	for(new i=1;i<=g_MaxPlayers;i++) if(g_HasRune[i])
		{
			API_PickUpRune(i)
		}		
}

public Event_CurWeapon(id)
{
	if (!is_user_alive(id) || g_HasRune[id] == 0) {
		return PLUGIN_CONTINUE
	}
	
	new weapon = read_data(2)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_tot.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
	return PLUGIN_CONTINUE
}

/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ ansicpg949\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset129 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1042\\ f0\\ fs16 \n\\ par }
*/
