/*
About:
This is a runemod powerup plugin that interfaces with runemod_base.amxx

About this rune:
Increases your maxpspeed by 100%

Credits:
Ops in #AMXmod @ Quakenet for alot of help ( + AssKicker & CheesyPeteza ) 
Thanks to BAILOPAN & PM for help on misc problems
kaddar for orginal runemod

Todo:
No plans
*/

#include <amxmodx>
#include <amxmisc>
#include <engine>
#include <cstrike>
#include <fun>
#include "runemod.inc"		// We need to include this file, as it contains info we need. Like #define`s and stocks

#define MAXSPEED 2.00			// How much to add to the max speed

new g_MaxPlayers
new g_HasRune[MAXPLAYERS+1] 	// This is the Array used to store if the user is holding a rune.(Remember the base plugin informs this plugin once he picks up a rune.)
new g_SpeedLocked[MAXPLAYERS+1]

public plugin_init() 
{
	register_plugin("RuneMod Spiderman", "1.0.0", "AdogeN")
	g_MaxPlayers = get_maxplayers()
	register_event("CurWeapon", "Event_CurWeapon", "be", "1=1")
	RegisterPlugin("SpidermanName","SpidermanDisc",{255,255,10},API_SPEEDCHANGE+API_ROUNDSTARTED+API_EVENTCHANGEWEAPON+API_USELANGSYSTEM)
}

public plugin_precache()
{
	precache_model("models/player/bmonster2/bmonster2.mdl")
	precache_model("models/knife/v_kung.mdl")
	precache_model("models/knife/p_tot.mdl")
}

public API_CurWeaponChange(id,WeaponIndex)
{
	if(g_SpeedLocked[id]) return PLUGIN_CONTINUE
	IncreaseSpeed(id,get_user_maxspeedint(id))
	return PLUGIN_CONTINUE
}
public API_UnLockSpeedChange(id)
{
	g_SpeedLocked[id] = 0
}

public Event_CurWeapon(id)
{
	if (!is_user_alive(id) || g_HasRune[id] == 0) {
		return PLUGIN_CONTINUE
	}
	
	new weapon = read_data(2)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_kung.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
	return PLUGIN_CONTINUE
}

public API_LockSpeedChange(id)
{
	g_SpeedLocked[id] = 1
}

public API_DropedRune(id,Reason) //This function is called by the base plugin to inform about the user droped his rune for whatever reason ( he could have used droprune or died )
{
	if(Reason != USER_DISCONNECTED)
		ResetUserSpeed(id)
	g_HasRune[id] = 0
	cs_reset_user_model(id)
	set_rendering(id,kRenderFxNone,0,0,0,kRenderTransAlpha,255)	
}

// This function is used base plugin to inform this plugin that a user has picked up the rune.
public API_PickUpRune(id) 
{
	if(!g_SpeedLocked[id])
		IncreaseSpeed(id,get_user_maxspeedint(id))
	g_HasRune[id] = 1
	cs_set_user_model(id, "bmonster2")
	new tclip, tammo 
	new weapon = get_user_weapon(id,tclip,tammo)
	if(weapon == CSW_KNIFE){
		entity_set_string(id, EV_SZ_viewmodel, "models/knife/v_kung.mdl")
		entity_set_string(id, EV_SZ_weaponmodel, "models/knife/p_tot.mdl")
	}
	if(cs_get_user_team(id)==CS_TEAM_T)
				{
					set_rendering(id,kRenderFxGlowShell,15,0,0,kRenderTransAlpha,255)
				}
				else
				{
					set_rendering(id,kRenderFxGlowShell,0,0,15,kRenderTransAlpha,255)
				}
}
public API_RoundStarted()
{
	new Speed
	for(new i=1;i<=g_MaxPlayers;i++) if(g_HasRune[i])
	{
		Speed = ResetUserSpeed(i)
		IncreaseSpeed(i,Speed)	
	}
	for(new i=1;i<=g_MaxPlayers;i++) if(g_HasRune[i])
		if(cs_get_user_team(i)==CS_TEAM_T)
				{
					set_rendering(i,kRenderFxGlowShell,15,0,0,kRenderTransAlpha,255)
				}
				else
				{
					set_rendering(i,kRenderFxGlowShell,0,0,15,kRenderTransAlpha,255)
				}
}
stock IncreaseSpeed(id,maxpspeed)
{
	set_user_maxspeed(id,(maxpspeed * MAXSPEED))	
}
stock get_user_maxspeedint(id)
{
	return floatround(get_user_maxspeed(id))
}
/* AMXX-Studio Notes - DO NOT MODIFY BELOW HERE
*{\\ rtf1\\ ansi\\ ansicpg949\\ deff0{\\ fonttbl{\\ f0\\ fnil\\ fcharset129 Tahoma;}}\n\\ viewkind4\\ uc1\\ pard\\ lang1042\\ f0\\ fs16 \n\\ par }
*/
